/*
 *	GOGO-no-coda
 *	Copyright(C) 2001 gogo-developer
 */

/*
 *	This file can be included by only engine/thread.h.
 */

#define INCL_DOSSEMAPHORES
#define INCL_DOSPROCESS
#include <os2.h>

typedef int       gogo_thread;
typedef HMTX      gogo_mutex;
typedef HMTX      gogo_semaphore;

BEGIN_C_DECLS
// int gogo_initialize_thread_unit(void);
#define gogo_initialize_thread_unit() (0)
int gogo_create_thread(gogo_thread*, gogo_thread_func, void *);
#define gogo_join_thread(pThread)               (DosWaitThread((PID*)(pThread),0))
#define gogo_destroy_thread(pThread)            (DosKillThread(*(pThread)))
//int gogo_create_mutex(gogo_mutex *pMutex);
#define gogo_create_mutex(pMutex)               (DosCreateMutexSem(NULL, (pMutex), 0, 0))
#define gogo_destroy_mutex(pMutex)              (DosCloseMutexSem(*(pMutex)))
#define gogo_lock_mutex(pMutex)                 (DosRequestMutexSem(*(pMutex), -1))
#define gogo_unlock_mutex(pMutex)               (DosReleaseMutexSem(*(pMutex)))
#define gogo_create_semaphore(pSemaphore)       (DosCreateMutexSem(NULL, (pSemaphore), 0, 0))
#define gogo_destroy_semaphore(pSemaphore)      (DosCloseMutexSem(*(pSemaphore)))
#define gogo_lock_semaphore(pSemaphore)         (DosRequestMutexSem(*(pSemaphore), -1))
#define gogo_unlock_semaphore(pSemaphore)       (DosReleaseMutexSem(*(pSemaphore)))
#define	gogo_trylocktimeout_semaphore(pSemaphore, timeout) \
												(DosRequestMutexSem(*(pSemaphore), timeout))
#define gogo_yield_thread()                     (DosSleep(0))
int gogo_get_cpu_count(int *, int *);
#define gogo_finalize_thread_unit()             (0)
END_C_DECLS
